<HEAD>
<TITLE>JFLA 2000</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 2000: relecture du papier 6</H1>

<P>Numero du papier: 6
<P>Titre du papier: Un compilateur CAML -> SYNDEX pour les 
applications de traitement de signal temps-réel distribués
<P>Auteurs: Jocelyn Serot

<P>Nom du rapporteur: Marc Pouzet

<P>Confiance en la note: 3

<P>Notation du papier: 2

<P>Commentaires aux auteurs:<P>
  Il s'agit d'un article montrant comment traduire un sous-ensemble de
  Caml Light sous forme de graphe de flot de donne'es
  synchrone. L'auteur met en avant l'inte're^t de l'ordre supe'rieur
  comme moyen de ge'ne'rer des sche'mas de graphe et donc de
  spe'cifier des syste`mes de manie`re plus concise.

  Ces graphes sont obtenus par interpre'tation abstraite d'un programme Caml
  ou` le domaine abstrait des valeurs est un ensemble de graphes flot
  de donne'es synchrones.

  Il s'agit d'un travail inte'ressant. Je ne suis cependant pas
  favorable a` sa publication en l'e'tat. Plusieurs points essentiels
  ne sont pas aborde's.

  1. Dans la traduction, il n'y a pas de garantie sur le
     synchronisme: le graphe produit peut ne pas e^tre
     synchrone. Conside'rons par exemple le programme Caml suivant:

        let f1 = fun x y -> x + y in
        let f2 = fun x -> x + 1 in
        (cond c (f1 x1) f2 x) + x1

     ou` c est une fonction boole'enne (e.g, fun x -> x = 0), 
     x et x1, des entre'es. Ce programme se beta-re'duit en:

        (cond c (fun y -> x1 + y) (fun x -> x + 1) x) + x1 et en:
        
        let px = c x in
        let tx = x1 + (when px x) in                      (1)
        let fx = (when (not px) x) + 1 in
        (default tx fx) + x1                              (2)

        qui n'est pas synchrone. x1 a l'horloge (c x), d'apre`s (1)
        autrement dit, il n'est la que lorsque (c x) est vrai et la
        contrainte (2) indique que x1 est la tout le temps.

     Il n'y a aucune discussion sur ces proble`mes et ils arrivent
     de`s que l'on a des ope'rateurs ne pre'servant pas les longueurs
     (conditionnelles, when, default,...). C'est pourtant toute la
     difficulte' du synchrone et des extensions d'ordre supe'rieur
     (voir les travaux de Caspi et Pouzet sur la programmation
     synchrone en Caml).

     La remarque en haut de la page 8, "Son expression en DROM est
     donc imme'diate ..." est un peu hative. 

  2. Une traduction en graphe "flot de donne'es" d'un programme Caml
     Light (me^me synchrone) peut ge'ne'rer un programme
     exponentiellement plus grand que l'entre'e puisque tout le
     partage initial a disparu. Par exemple:

        let double x = (x+1,x+2)
        let exp x = double(double(double x))

        let double2 f x = f (f x)

     Ce point devrait e^tre discute'.

  3. Page 10, l'auteur rappelle l'inte're^t des de'finitions
     re'cursives de valeurs. Les boucles de causalite' sont
     e'limine'es en forcant le repliage d'une fonction a` travers un
     de'lai.

     Est-ce une contrainte syntaxique ? Est-il possible d'e'crire des
     de'finitions mutuellement re'cursives ? 

  4. Une comparaison avec les travaux de Mary Sheram sur Lava ou John
     Launchburry sur Hawk visant a` faire de la programmation flot de
     donne'es en Haskell serait inte'ressante. 

<P>Commentaires reserves au comite de programme:<P>
  Je n'ai pas e'te' emballe' par cet article qui montre comment
  interpre'ter un sous ensemble de Caml Light en des graphes de flot
  de donne'es synchrone. C'est une ide'e assez classique et l'auteur
  n'aborde pas les points importants: synchronisme, causalite',
  croissance du code. Il me semble que cet article n'est pas
  acceptable en l'e'tat.

</BODY>
</HTML>
